﻿BTSC = {};

function BTSC.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function BTSC:load(xmlFile)

    self.BTSCBaleTriggerCallback = BTSC.BTSCBaleTriggerCallback;

    if self.isServer then
        self.BTSCBaleTriggerId = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.BTSCBaleTrigger#index"));
        if self.BTSCBaleTriggerId ~= nil then
            addTrigger(self.BTSCBaleTriggerId, "BTSCBaleTriggerCallback", self);
        end
    end
end;

function BTSC:delete()
    if self.isServer then
        if self.BTSCBaleTriggerId ~= nil then
            removeTrigger(self.BTSCBaleTriggerId);
        end
    end
end;


function BTSC:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BTSC:keyEvent(unicode, sym, modifier, isDown)
end;

function BTSC:update(dt)
end;

function BTSC:updateTick(dt)
end;

function BTSC:draw()
end;

function BTSC:BTSCBaleTriggerCallback(triggerId, otherActorId, onEnter, onLeave, onStay, otherShapeId)
    if onEnter then
        -- this happens if a compound child of a deleted compound is entering
        if otherActorId ~= 0 then
            local object = g_currentMission:getNodeObject(otherActorId);
            if object ~= nil then
                if object:isa(Bale) then
                    local fillLevel = object:getFillLevel();
                    local fillType = object:getFillType();
                    if self:allowFillType(fillType, false) then
                        self:setFillLevel(self:getFillLevel(fillType)+fillLevel, fillType);
                    end
                    object:delete();
                end;
            end;
        end;
    end;
end;